' selects a random picture from a single directory
' copyright 2004-2009 Erik Siers
' all rights reserved

SUB recurseDirs(folder AS STRING, c AS LONG)
    'follows a single branch all the way
    'stack space, don't fail me now
    'I can also do this (in VB) with the FileSystemObject but it's too slow for my tastes...
    ON ERROR GOTO Whoops

    LOCAL x AS STRING, a AS LONG, fldrs AS LONG, extn AS STRING, lFiles AS LONG
    DIM subdirs() AS STRING, localFiles() AS STRING

    fldrs = -1: lFiles = -1

    IF RIGHT$(folder, 1) <> "\" THEN folder = folder & "\"

    x = DIR$(folder, %SUBDIR)
    DO UNTIL "" = x
        IF ("." = x) OR (".." = x) THEN GOTO Looper
        a = GETATTR(folder & x)
        IF %FILE_ATTRIBUTE_DIRECTORY = (a AND %FILE_ATTRIBUTE_DIRECTORY) THEN
            INCR fldrs
            REDIM PRESERVE subdirs(fldrs)
            subdirs(fldrs) = folder & x
        ELSE
            'build localFiles, to be appended to fileLs later
            a = INSTR(-1, x, ".")
            IF 0 = a THEN GOTO Looper
            extn = LCASE$(MID$(x, a + 1))
            SELECT CASE extn
                CASE "bmp", "emf", "gif", "jpe", "jpeg", "jpg", "png", "wmf"
                    INCR lFiles
                    REDIM PRESERVE localFiles(lFiles)
                    localFiles(lFiles) = x
            END SELECT
        END IF
Looper:
        x = DIR$
    LOOP

    IF lFiles > -1 THEN
        ARRAY SORT localFiles(), COLLATE UCASE
        REDIM PRESERVE fileLs(c + lFiles + 1)
        FOR a = 0 TO lFiles
            fileLs (c + a + 1) = folder & localFiles(a)
        NEXT
        c = c + lFiles + 1
    END IF

    IF fldrs > -1 THEN
        ARRAY SORT subdirs(), COLLATE UCASE
        FOR a = 0 TO fldrs
            recurseDirs subdirs(a), c
        NEXT
    END IF

Whoops:
    ERRCLEAR
END SUB

SUB makeImgList (x AS STRING)
    DIM c AS LONG, n AS LONG

    c = -1

    recurseDirs x, c
END SUB
