' makeBG22
' by Erik Siers

' copyright 2004-2009 Erik Siers
' source available under terms of the GNU GPL

' This creates a list of files, sorts it, then writes a .vbs file for inclusion
' in a web page. I use it for random backgrounds, thus the name, but it could
' have numerous other uses.
' It's meant for use on the local machine, and the final .vbs file might
' need some changes to work on the www.
' It would be trivial to make this spew out javascript and proper URLs...
' I just didn't.

' This is probably the final version of makeBG, as it finally does everything
' the way I want it to: no dependency on external programs (as of makeBG6),
' proper recursion (also as of makeBG6), correct sorting (as of makeBG8), timing
' of the whole run (as of makeBG15)... and finally noticed the comments were
' still showing the old, old info (as of makeBG22).

#OPTION VERSION3
#TOOLS OFF
#DIM ALL
#DEBUG ERROR ON
#COMPILE EXE

GLOBAL fileLs() AS STRING

#INCLUDE "Win32API.inc"
#INCLUDE "ImageLister.bi"


FUNCTION PBMAIN()
    DIM started AS DOUBLE, elapsed AS DOUBLE
    started = TIMER
    DIM x AS STRING, c AS LONG, lh AS INTEGER
    DIM cdir AS STRING, lc AS LONG
    DIM cmd AS STRING, h AS STRING, fi AS LONG, fc AS LONG

    cdir = CURDIR$
    IF RIGHT$(cdir,1) <> "\" THEN cdir = cdir & "\"
    lc = LEN(cdir) + 1
    makeImgList cdir
    CHDIR cdir
    fi = FREEFILE
    ON ERROR GOTO noimages
    c = UBOUND(fileLs)
    IF c < 0 THEN EXIT FUNCTION
    OPEN "bg.vbs" FOR OUTPUT AS fi
        lh = LEN(h) + 1
        PRINT #fi, "basePath = " & $DQ & cdir & $DQ
        PRINT #fi, "'" & STR$(UBOUND(fileLs) + 1) & " images"
        PRINT #fi, "fileNames = Array(" & $DQ & MID$(fileLs(0),lc) & $DQ;
        FOR c = 1 TO UBOUND(fileLs)
            PRINT #fi, ", " & $DQ & MID$(fileLs(c),lc) & $DQ;
        NEXT
        PRINT #fi, ")"
    CLOSE
    elapsed = TIMER
    elapsed = elapsed - started
    IF elapsed < 0 THEN elapsed = elapsed + 86400
    ? "Done in " & TRIM$(STR$(elapsed)) & " seconds.", %MB_SYSTEMMODAL OR %MB_ICONINFORMATION, "makeBG17"
noimages:
    ERRCLEAR    ' possibly no images
END FUNCTION
